#import <Flutter/Flutter.h>
#import <Apptics/Apptics.h>
#import <Apptics/ZAEnums.h>
#import <AppticsEventTracker/AppticsEventTracker.h>
#import <AppticsScreenTracker/AppticsScreenTracker.h>
#import <AppticsInAppUpdate/AppticsInAppUpdate.h>
#import "APRateUs.h"
#import "ARCustomHandler.h"
#import "APStoreReviewManager.h"
#import <AppticsRemoteConfig/AppticsRemoteConfig.h>

@interface AppticsFlutterPlugin : NSObject<FlutterPlugin,UINavigationControllerDelegate, ARCustomHandler>
@property (nonatomic) NSTimeInterval lastFetchedTime;
@end

@interface AppticsCrashFlutterPlugin : NSObject

@property (strong, nonatomic) NSMutableDictionary *uniqErrors;

+(AppticsCrashFlutterPlugin*) shared;
- (void) sendPendingNonFatalsReports;
- (void) checkForNonFatalAndSendToServer;
- (void) uploadCrashSuccessNotification : (NSNotification*) notification;

@end

@interface Analytics (AFLExtension)
- (void) saveFLNonFatalsUniqueId : (NSString*) uniqueId issueName : (NSString *)issueName message : (NSString *)message stackTrace : (NSString*)stackTrace crashProperties : (NSMutableDictionary*) crashProperties;
- (void) saveFLFatals : (NSString *)issueName message : (NSString *)message stackTrace : (NSString*)stackTrace crashProperties : (NSMutableDictionary*) crashProperties;
@end

@interface ZAFileManager (AFLExtension)
+ (NSArray*) getFLCrashes;
+ (void) deleteAllFLCrashes;
+ (NSArray*) getFLNonFatals;
+ (void) deleteAllFLNonFatals;
+ (NSArray*) getFLNonFatalsMeta;
+ (void) deleteAllFLNonFatalsMeta;
+ (void) archiveFLCrashReport:(NSDictionary*)crashReport withFileName : (NSString*) filePath;
    + (id) unarchiveFLCrashReportForFileName : (NSString*) filePath;
@end

